## performous-composer 2.0+20181009

=== CMakeLists.txt ===
project("Composer" CXX C)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)
set(PROJECT_VERSION "2.0")
set(BUILD_SHARED_LIBS OFF)
#FIXME: Changes in version number or project name must manually also be put to:
#       platform/mingw-cross-env/makeinstaller.py

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}")

include(platform/packaging.cmake)

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Find all the libs that don't require extra parameters
foreach(lib AVFormat SWResample SWScale Qt5Core Qt5Widgets Qt5Gui Qt5Xml Qt5Multimedia)
	find_package(${lib} REQUIRED)
	include_directories(${${lib}_INCLUDE_DIRS})
	list(APPEND LIBS ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${lib}_EXECUTABLE_COMPILE_FLAGS}")
endforeach(lib)

# Sources
add_subdirectory(src)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)

set(EXENAME ${CMAKE_PROJECT_NAME})
set(CMAKE_AUTOMOC FALSE)
if(UNIX)
	# On UNIX, binary name is lowercase with no spaces
	string(TOLOWER ${EXENAME} EXENAME)
	string(REPLACE " " "-" EXENAME ${EXENAME})
endif()

# Headers that need MOC need to be defined separately
file(GLOB MOC_HEADER_FILES editorapp.hh notelabel.hh notegraphwidget.hh textcodecselector.hh gettingstarted.hh pitchvis.hh synth.hh)

file(GLOB SOURCE_FILES "*.cc")
file(GLOB HEADER_FILES "*.hh")
file(GLOB RESOURCE_FILES "../*.qrc")
file(GLOB UI_FILES "../ui/*.ui")

# Qt pre-processors
QT5_ADD_RESOURCES(RESOURCE_SOURCES ${RESOURCE_FILES})
QT5_WRAP_UI(UI_SOURCES ${UI_FILES} )
QT5_WRAP_CPP(MOC_SOURCES ${MOC_HEADER_FILES})

# Generate config.hh
configure_file(config.cmake.hh "${CMAKE_BINARY_DIR}/src/config.hh" @ONLY)

include_directories(${CMAKE_BINARY_DIR}/src)
include_directories(${CMAKE_SOURCE_DIR}/src)

# Final binary
add_executable(${EXENAME} ${HEADER_FILES} ${SOURCE_FILES} ${MOC_SOURCES} ${RESOURCE_SOURCES} ${UI_SOURCES})
target_link_libraries(${EXENAME} ${LIBS})
target_link_libraries(${EXENAME} swresample) #FIXME!! should be included in ${LIBS}

# We don't currently have any assets, so on Windows, we just install to the root installation folder
if(UNIX)
	install(TARGETS ${EXENAME} DESTINATION bin)
	install(FILES "../platform/composer.desktop" DESTINATION "share/applications/")
	install(FILES "../icons/composer.png" DESTINATION "share/pixmaps")
else()
	install(TARGETS ${EXENAME} DESTINATION .)
endif()

## performous-composer 2.0%2B20181009-gitbeeea23

=== debian/control ===
Source: performous-composer
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Dominik George <natureshadow@debian.org>,
Section: games
Priority: optional
Build-Depends:
 cmake,
 debhelper (>= 11),
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libswresample-dev,
 libswscale-dev,
 qtbase5-dev,
 qtmultimedia5-dev,
Standards-Version: 4.3.0
Homepage: https://performous.org/composer
Vcs-Git: https://salsa.debian.org/games-team/performous-composer.git
Vcs-Browser: https://salsa.debian.org/games-team/performous-composer

Package: performous-composer
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 performous,
Description: song editor for creating (and converting) notes for music games
 Composer is a song editor for creating (and converting) notes for music
 games in various formats.  It attempts to make the process easy by
 automating as much as possible while providing a simple and attractive
 interface to do the remaining manual work.
 .
 Key features of Composer include:
 .
  * Song pitch analysis based on the esteemed algorithms from Perfomous.
  * Zoomable interface to quickly get an overview or doing very precise timing.
  * Possibility to synthesize the notes to get a feel of their "sound".
  * Import/export in various formats including:
    * SingStar XML
    * UltraStar TXT
    * Frets on Fire MIDI
 .
 Composer has a rather distinguished workflow: for example, the lyrics are
 imported as a whole and each time you manually put a note in place, the
 others automatically adjust to take use of the new information in providing
 a better guess of the pitch and timing.  In a sense, you are not actually
 creating a song, but fixing and tuning the result of what the computer
 thinks the notes should be like.

## performous-composer 2.0+20181009-gitbeeea23

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: performous-composer
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Dominik George <natureshadow@debian.org>,
 Section: games
@@ -24,6 +25,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ libqt5multimedia5-plugins,
 Enhances:
  performous,
 Description: song editor for creating (and converting) notes for music games
@@ -34,7 +36,7 @@
  .
  Key features of Composer include:
  .
-  * Song pitch analysis based on the esteemed algorithms from Perfomous.
+  * Song pitch analysis based on the esteemed algorithms from Performous.
   * Zoomable interface to quickly get an overview or doing very precise timing.
   * Possibility to synthesize the notes to get a feel of their "sound".
   * Import/export in various formats including:

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install

	# Rename to performous-composer, because php-composer owns the composer namespace
	mv debian/performous-composer/usr/bin debian/performous-composer/usr/games
	mv debian/performous-composer/usr/games/composer \
	    debian/performous-composer/usr/games/performous-composer
	mv debian/performous-composer/usr/share/pixmaps/composer.png \
	    debian/performous-composer/usr/share/pixmaps/performous-composer.png
	mv debian/performous-composer/usr/share/applications/composer.desktop \
	    debian/performous-composer/usr/share/applications/performous-composer.desktop
	sed -i -e 's/\(composer\)/performous-\1/i' \
	    debian/performous-composer/usr/share/applications/performous-composer.desktop

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/composer-$1\.tar\.gz/ \
  https://github.com/performous/composer/tags .*/v?(\d\S+)\.tar\.gz
